﻿class DetailledAccount
{
    private decimal amount; // Attribute to hold the current balance
    private string fName;  // Attribute to hole the first name
    private string lName;  // Attribute to hold the last name

    public DetailledAccount(string fNameParam, string lNameParam)
    {
        fName = fNameParam;
        lName = lNameParam;
        // What will be the value of the "amount" instance variable?
    }

    public decimal GetAmount() { return amount; }
    /*
     * Note that we do not write a getter for the last name,
     * and another one for the first name. Instead, we write
     * a getter that return both, separated by a comma.
     */
    public string GetName() { return lName + ", " + fName; }
    /*
     * We write two methods to modify the value of the amount attribute.
     * Note that we don't write a setter for amount.
     */
    public void Deposit(decimal depositParam) { amount += depositParam; }
    public void Withdraw(decimal depositParam) { amount -= depositParam; }

    /*
     * Our ToString method is pretty straightforward, but 
     * note that it calls the GetName method instead of accessing the fName and lName
     * attributes.
     */
    public override string ToString()
    {
        return GetName() + " currently has " + $"{amount:C}";
    }
    /*
     * We add a second, more complex constructor, that actually
     * build on top of the previous one.
     */
    public DetailledAccount(decimal amountParam, string fNameParam, string lNameParam) : this(fNameParam, lNameParam)
        /* This last part (" : this(fNameParam, lNameParam)") is essentially saying 
         * "do as the previous constructor that was defined, the one that takes a string,
         * and then another string, as arguments, and then do as follows".
         */
    {
        /*
         * Once the program is done executing the code of the
         * previous constructor, it executes the following:
         */
        amount = amountParam;
    }
}


