﻿/*
 * Clément Aubert
 * 2018 09 18
 * CSCI 1301 -- Lab 10 -- Fall 2018
 */

class Room
{
    /*
     * Initial Set-Up
     * Declaring three fields and the corresponding getters and setters.
     */

    private string name;
    // Double are the "right" datatype to hold measurements of a room. Not too precise, but capable of holding decimal values.
    private double width;
    private double length;

    public void SetName(string nameP) { name = nameP; }
    public void SetWidth(double widthP) { width = widthP; }
    public void SetLength(double lengthP) { length = lengthP; }

    public string GetName() { return name; }
    public double GetWidth() { return width; }
    public double GetLength() { return length; }

    /*
     * Adding Methods
     */

    public Room() { } // I added a "custom default" constructor so that my program would still compile, even if I don't have access to the default constructor anymore.
    public Room(string nameP, double widthP, double lengthP)
    {
        name = nameP;
        width = widthP;
        length = lengthP;
    }
    public double GetArea() { return width * length; }

    /*
     * Internationalization of the Room Class
     * We will be using constants, since the ration meter to foot, and foot to meter, is not going to change!
     */

    private const double FTOM = 0.3048; // FTOM stands for "Foot to meter"
    private const double MTOF = 3.28084; // MTOF stands for "Meter to foot"

    public double GetWidthInFeet() { return width * MTOF; } // To obtain the width in feet, we simply take the width in meters, and multiply it by the ratio set earlier.
    public double GetLengthInFeet() { return length * MTOF; } // … and similarly for the length.

    public double GetAreaInFeet(){ return GetArea() * MTOF * MTOF; } // Be careful! We have to multiply by the ratio twice! Can you see why?
     
    // Alternate definition of this method:
    public double GetAreaInFeetAlternate() { return GetWidthInFeet() * GetLengthInFeet(); }

    // And finally, a constructor that takes only two parameters:
    public Room (double widthPFeet, double lengthPFeet)
    {
        length = lengthPFeet * FTOM; // We assume the user will give us the length in feet, and we have to convert it into meters.
        width = widthPFeet * FTOM; // Similarly for the length.
    }

    /*
     * A ToString Method
     */

    public override string ToString() // We can return whatever string we want, but it's better to try to make it as informative and as good-looking as possible. Here is an attempt:
    {
        return $"The name of the room is \"{GetName()}\", its dimensions are:\n"
            + $"\t {GetWidth()} x {GetLength()} = {GetArea()} (in square meters)\n"
            + $"\t {GetWidthInFeet()} x {GetLengthInFeet()} = {GetAreaInFeet()} (in square feet)\n";
    }

}

