---
title: CSCI 1301 -- Lab 17
author: Clément Aubert
lang: en
fontsize: 10pt
documentclass: scrartcl
numbersections: true
links-as-notes: true
papersize: letter
geometry: margin=1in
keywords:
- Computer Science
- Problem solving methods
- Syllabus
- Augusta University
- Bachelor of Science
---

# Basic Conditional Statements

Read all the instructions in this part before starting to type code.
Create a new project, and write portions of code that perform the following:

#. Ask the user for an integer, and display on the screen "You were born after me" if the number is strictly greater than your year of birth.
#. Ask the user for an integer, and display on the screen "Between $-1$ and $1$" if the number is greater than or equal to $-1$ and less than or equal to $1$.
#. Ask the user for an integer, and display on the screen "Not between $-1$ and $1$" if the number is greater than $1$ or less than $-1$.
#. Ask the user for an integer, and display on the screen "Odd" or "Even", depending if the number is odd or even.
#. Ask the user for an integer, and display on the screen "Negative" if the integer is negative, "Positive" if the integer in positive, and nothing if the integer is $0$.
#. Ask the user for an integer, and display on the screen "positive and odd" if the number is positive and odd, "positive and even" if the number is positive and even, "negative and odd" if the number is negative and odd, "negative and even" if the number is negative and even, and "You picked $0$" if the number is $0$.

For each of those questions, write *on paper* whenever you should use `if`, `if-else`, `if-else-if` or nested conditional structures, and what the condition(s) should be.
Once you feel confident, write the code in VS, and then test it intensively: enter all kind of values (positive and odd, negative and even, $0$,  and remember that [$0$ is even](https://en.wikipedia.org/wiki/Parity_of_zero), etc.) and make sure that what is displayed on the screened is always correct.


# Problem Solving

You are asked to write a simple program that computes the total price for a group of people to enter a park.

Your program should:

- Ask the user how many adults and how many children want to enter the park,
- If the group comprises $6$ persons or more, offer to purchase a group pass for \$$30$ (that allows all the group to enter the park),
- Compute and display the total price on the screen, knowing that:
    - Adults pay \$$7$,
    - Children pay \$$4$,
    - *If* purchasing the group pass allowed the group to save money (which isn't always the case!), you should display on the screen the amount saved.

Some tips:

- When asking "yes" / "no" questions, treat "y" and "Y" as a "Yes", and any other string as a "No".
- Note that we will sell the pass even if the user is not gaining money by doing so (for instance, if 6 children want to enter, $\$4 \times 6 = \$24 > \$ 30$, but we would still sell them the pass).
