---
title: CSCI 1301 -- Lab
author: Clément Aubert
lang: en
fontsize: 10pt
documentclass: scrartcl
numbersections: true
links-as-notes: true
papersize: letter
geometry: margin=1in
keywords:
- Computer Science
- Problem solving methods
- Syllabus
- Augusta University
- Bachelor of Science
---

~~~~~~~{.cs .numberLines .lineAnchors}
using System;
class Welcome
{
   static void Main()
   {
      Console.WriteLine("Welcome to the lab portion of CSCI 1301!");                   
   }
}
~~~~~~~

[Back to the class page](../)

# August

| Day | #      | Links | Content | 
| --- | ---    | --- | --- | 
| 16  | Lab 01 | [webpage](01/) • [printable document](01/index.pdf) • [editable document](01/index.docx)   | Introduction | 
| 21  | Lab 02 | [webpage](02/) • [printable document](02/index.pdf) • [editable document](02/index.docx)   | Editing Your First Program | 
| 23  | Lab 03 | [webpage](03/) • [printable document](03/index.pdf) • [editable document](03/index.docx)   | Your First Project and Variables | 
| 28  | Lab 04 | [webpage](04/) • [printable document](04/index.pdf) • [editable document](04/index.docx)   | Documentation, Numerical Operations and Replacing | 
| 30  | Lab 05 | [webpage](05/) • [printable document](05/index.pdf) • [editable document](05/index.docx)   | Reading a String from the user, numeric datatypes | 

# September

| Day | #      | Links | Content | 
| --- | ---    | --- | --- | 
| 4  | Lab 06 | [webpage](06/) • [printable document](06/index.pdf) • [editable document](06/index.docx)  | Reading numerical values from the user, Milestone #1, First Problem | 
| 6  | Lab 07 | [webpage](07/) • [printable document](07/index.pdf) • [editable document](07/index.docx)  | First class manipulation (the `Rectangle` class) | 
| 11 | Lab 08 | [webpage](08/) • [printable document](08/index.pdf) • [editable document](08/index.docx)  | Solution to the `Rectangle` class, write your `PreciseRectangle` class | 
| 13 | Lab 09 | [webpage](09/) • [printable document](09/index.pdf) • [editable document](09/index.docx)  | Your own `Circle` class | 
| 18 | Lab 10 | [webpage](10/) • [printable document](10/index.pdf) • [editable document](10/index.docx)  | A(nother) `Room` Class | 
| 20 | Lab 11 | [webpage](11/) • [printable document](11/index.pdf) • [editable document](11/index.docx)  | Project #2 | 
| 25 | Lab 12 | [webpage](12/) • [printable document](12/index.pdf) • [editable document](12/index.docx)  | Review Session (`Room` and `Grade` classes) | 
| 27 | Lab 13 | [webpage](13/) • [printable document](13/index.pdf) • [editable document](13/index.docx)  | `DetailledAccount` class and Tip Calculator | 

# October

| Day | #      | Links | Content | 
| --- | ---    | --- | --- | 
| 2 | Lab 14 | [webpage](14/) • [printable document](14/index.pdf) • [editable document](14/index.docx)  | Milestone #2 | 
| 4 | Lab 15 | [webpage](15/) • [printable document](15/index.pdf) • [editable document](15/index.docx)  | Exam #1 Debriefing | 
| 9 | Lab 16 | [webpage](16/) • [printable document](16/index.pdf) • [editable document](16/index.docx)  | Booleans, conditions, a guessing game| 
| 16 | Lab 17 | [webpage](17/) • [printable document](17/index.pdf) • [editable document](17/index.docx)  | Basic Conditional Statements | 
| 18 | Lab 18 | [webpage](18/) • [printable document](18/index.pdf) • [editable document](18/index.docx)  | Reading and comparing `char` | 
| 23 | Lab 19 | [webpage](19/) • [printable document](19/index.pdf) • [editable document](19/index.docx)  | `loan` class, practicing `if` and `switch` | 
| 25 | Lab 20 | [webpage](20/) • [printable document](20/index.pdf) • [editable document](20/index.docx)  | User Input Validation | 
| 30 | Lab 21 | [webpage](21/) • [printable document](21/index.pdf) • [editable document](21/index.docx)  | `while` and `do…while` loops | 

# November

| Day | #      | Links | Content | 
| --- | ---    | --- | --- | 
| 1 | Lab 22 | [webpage](22/) • [printable document](22/index.pdf) • [editable document](22/index.docx)  | Hints for Project #3 | 
| 6 | No Lab |  | Review Session | 
| 8 | No Lab |  | Exam #2 | 
| 13 | Lab 23 |  [webpage](23/) • [printable document](23/index.pdf) • [editable document](23/index.docx)  | `for` loops| 
| 15 | Lab 24 |  [webpage](24/) • [printable document](24/index.pdf) • [editable document](24/index.docx)  | `for` loops (bis) | 
| 20 | Lab 25 |  [webpage](25/) • [printable document](25/index.pdf) • [editable document](25/index.docx)  | Arrays | 
| 27 | Lab 26 |  [webpage](26/) • [printable document](26/index.pdf) • [editable document](26/index.docx)  | Array Algorithms | 
| 29 | Lab 27 |  [webpage](27/) • [printable document](27/index.pdf) • [editable document](27/index.docx)  | The "Wireless Service Provider" class | 

# December

| Day | #      | Links | Content | 
| --- | ---    | --- | --- | 
| 04 | Lab 28 |  [webpage](28/) • [printable document](28/index.pdf) • [editable document](28/index.docx)  | A Random Guessing Game| 



<!--
Wireless Service Provider Problem
-->


<!--
| Jan. ||
| --- | --- |
| 04 - Lab 01| [webpage](01/), [printable document](01/index.pdf)|
| 09 - Lab 02| [webpage](02/), [printable document](02/index.pdf)|
| 11 - Lab 03| [webpage](03/), [printable document](03/index.pdf)|
| 16 - Lab 04| [webpage](04/), [printable document](04/index.pdf)|
| 18 - Lab 05| [webpage](05/), [printable document](05/index.pdf)|
| 23 - Lab 06| [webpage](06/), [printable document](06/index.pdf)|
| 25 - Lab 07 - Milestone #1| [webpage](07/), [printable document](07/index.pdf)|
| 30 - Lab 08| [webpage](08/), [printable document](08/index.pdf)|


| Feb. ||
| --- | --- |
| 01 - Lab 09| [webpage](09/), [printable document](09/index.pdf)|
| 06 - Lab 10| [webpage](10/), [printable document](10/index.pdf)|
| 08 - Lab 11| [webpage](11/), [printable document](11/index.pdf)|
| 13 - No Lab| Review Session |
| 15 - No Lab| Exam #1 Correction |
| 20 - Lab 12 - Project #3 | [webpage](12/), [printable document](12/index.pdf)|
| 22 - Lab 13 | [webpage](13/), [printable document](13/index.pdf)|
| 27 - Lab 14 | [webpage](14/), [printable document](14/index.pdf)|

| Mar. ||
| --- | --- |
| 01 - Lab 15| [webpage](15/), [printable document](15/index.pdf)|
| 06 - Lab 16 - Milestone #2 | [webpage](16/), [printable document](16/index.pdf)|
| 13 - Lab 17| [webpage](17/), [printable document](17/index.pdf)|
| 15 - Lab 18 - Guide for Project #4 | [webpage](18/), [printable document](18/index.pdf)|
| 20 - Lab 19 | [webpage](19/), [printable document](19/index.pdf)|
| 22 - Lab 20 | [webpage](20/), [printable document](20/index.pdf)|
| 27 - Lab 21 | [webpage](21/), [printable document](21/index.pdf)|
| 29 - Lab 22 - Exam #2 | [webpage](22/), [printable document](22/index.pdf)|

| Apr. ||
| --- | --- |
| 10 - Lab 23 | [webpage](23/), [printable document](23/index.pdf)|
| 12 - Lab 24 - Project #5 | [webpage](24/), [printable document](24/index.pdf)|
| 17 - Lab 25 | [webpage](25/), [printable document](25/index.pdf)|
| 19 - Lab 26 | [webpage](26/), [printable document](26/index.pdf)|
| 24 - Lab 27 | [webpage](27/), [printable document](27/index.pdf)|
-->


<footer>
 The lab uses a [custom style](templates/VisualCS.theme) based on [skylighting](https://github.com/jgm/skylighting) to [highlight](https://pandoc.org/MANUAL.html#syntax-highlighting) the code with [pandoc](https://pandoc.org).
 </footer>
